function varargout = Minfo(varargin)
% MINFO MATLAB code for Minfo.fig
%      MINFO, by itself, creates a new MINFO or raises the existing
%      singleton*.
%
%      H = MINFO returns the handle to a new MINFO or the handle to
%      the existing singleton*.
%
%      MINFO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MINFO.M with the given input arguments.
%
%      MINFO('Property','Value',...) creates a new MINFO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Minfo_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Minfo_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Minfo

% Last Modified by GUIDE v2.5 10-Jun-2014 20:03:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Minfo_OpeningFcn, ...
                   'gui_OutputFcn',  @Minfo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Minfo is made visible.
function Minfo_OpeningFcn(hObject, ~, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Minfo (see VARARGIN)

% Choose default command line output for Minfo
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

loc1=get(handles.ax_entropy,'position');
loc2=get(handles.ax_info,'position');
loc3=[loc2(1) loc2(2) loc2(3) loc1(4)+loc1(2)-loc2(2)];
setappdata(handles.output,'loc1',loc1);
setappdata(handles.output,'loc2',loc2);
setappdata(handles.output,'loc3',loc3);
setappdata(handles.output,'loaded',false);
% UIWAIT makes Minfo wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Minfo_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in loadfile_button.
function loadfile_button_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to loadfile_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename,pathname] = uigetfile({'*.mat'},'Select the .mat file containing ''spikes'' variable');
if(filename==0),return; end
expr = regexp(filename,'(?<basename>.*)\.(plx|abf|mat)','names');
basename = expr.basename;
mat_file=sprintf('%s%s',pathname,filename);
setappdata(handles.output,'basename',basename);
setappdata(handles.output,'pathname',pathname);
setappdata(handles.output,'mat_file',filename);
setappdata(handles.output,'fullfile',mat_file);

names=whos('-file',mat_file);
names={names.name};

% check for required variables
loc=find(strcmp(names,'spikes'),1,'first');
if(isempty(loc))
    set(handles.status_label,'String','No spikes found. Please load another .mat file.');
    return;
end
loc=find(strcmp(names,'REPEATS'),1,'first');
if(isempty(loc))
    set(handles.status_label,'String','Variable ''REPEATS'' not found. Please load another .mat file.');
    return;
end
loc=find(strcmp(names,'UNIQUES'),1,'first');
if(isempty(loc))
    set(handles.status_label,'String','Variable ''UNIQUES'' not found. Please load another .mat file.');
    return;
end
load(mat_file,'spikes','REPEATS','UNIQUES');
setappdata(handles.output,'spikes',spikes); %#ok<NODEF>
if(any(strcmp(names,'trial_length')))
    load(mat_file,'trial_length');
else
    trial_length=max(cellfun(@max,spikes(:)));
end
setappdata(handles.output,'trial_length',trial_length);
setappdata(handles.output,'REPEATS',REPEATS);
setappdata(handles.output,'UNIQUES',UNIQUES);
setappdata(handles.output,'MAX_FREQ',str2double(get(handles.maxfreq_field,'String')));

% populate cell list
N=size(spikes,1);
ind=1:N;
list_string=cellstr(strcat('Cell',{' '},cellstr(num2str(ind'))));

% get firing rates
rates=mean(cellfun(@length,spikes),2)/trial_length;
setappdata(handles.output,'rates',rates);
setappdata(handles.output,'ind',ind);
set(handles.cell_listbox,'String',list_string,'Max',N);

setappdata(handles.output,'loaded',true);
calculate_coefficients(handles);

update_plots(handles);
setappdata(handles.output,'loaded',true);


% updates Fourier coefficients. If new frequency is lower, it's easy.
function update_coefficients(handles,new_freq)
if(~getappdata(handles.output,'loaded')),return; end
freq=getappdata(handles.output,'freq_orig');
old_freq=freq(end);
dF=freq(2)-freq(1);
if(new_freq<old_freq+dF)
    ind=freq<=new_freq;
    
    coeffs_repeat=getappdata(handles.output,'coeffs_repeat_orig');
    coeffs_unique=getappdata(handles.output,'coeffs_unique_orig');
    coeffs_repeat_adjusted=getappdata(handles.output,'coeffs_repeat_adjusted_orig');
    coeffs_unique_adjusted=getappdata(handles.output,'coeffs_unique_adjusted_orig');
    
    setappdata(handles.output,'coeffs_repeat',coeffs_repeat(:,:,ind));
    setappdata(handles.output,'coeffs_unique',coeffs_unique(:,:,ind));
    setappdata(handles.output,'coeffs_repeat_adjusted',coeffs_repeat_adjusted(:,:,ind));
    setappdata(handles.output,'coeffs_unique_adjusted',coeffs_unique_adjusted(:,:,ind));
    
    setappdata(handles.output,'freq',freq(ind));
else
    calculate_coefficients(handles);
end


function calculate_coefficients(handles)
if(~getappdata(handles.output,'loaded')),return; end
spikes=getappdata(handles.output,'spikes');

% perform initial calculation
max_freq=str2double(get(handles.maxfreq_field,'String'));

set(handles.status_label,'String','Calculating Fourier coefficients...'); drawnow;
count=cellfun(@length,spikes);
trial_length=getappdata(handles.output,'trial_length');
[coeffs,freq]=spiketime2fourier(spikes,max_freq,trial_length);
[coeffs_adjusted,deleted]=adjust_coeffs(coeffs,count);

set(handles.status_label,'String','Done.');

REPEATS=getappdata(handles.output,'REPEATS');
UNIQUES=getappdata(handles.output,'UNIQUES');
REPEATS_adjusted=REPEATS; REPEATS_adjusted(deleted)=[];
UNIQUES_adjusted=UNIQUES; UNIQUES_adjusted(deleted)=[];
coeffs_repeat_adjusted=coeffs_adjusted(:,REPEATS_adjusted,:);
coeffs_unique_adjusted=coeffs_adjusted(:,UNIQUES_adjusted,:);
coeffs_repeat=coeffs(:,REPEATS,:);
coeffs_unique=coeffs(:,UNIQUES,:);

setappdata(handles.output,'coeffs_repeat',coeffs_repeat);
setappdata(handles.output,'coeffs_unique',coeffs_unique);
setappdata(handles.output,'coeffs_repeat_adjusted',coeffs_repeat_adjusted);
setappdata(handles.output,'coeffs_unique_adjusted',coeffs_unique_adjusted);
setappdata(handles.output,'coeffs_repeat_orig',coeffs_repeat);
setappdata(handles.output,'coeffs_unique_orig',coeffs_unique);
setappdata(handles.output,'coeffs_repeat_adjusted_orig',coeffs_repeat_adjusted);
setappdata(handles.output,'coeffs_unique_adjusted_orig',coeffs_unique_adjusted);
setappdata(handles.output,'freq',freq);
setappdata(handles.output,'freq_orig',freq);

% generate entropy plot
function update_plots(handles)
if(~getappdata(handles.output,'loaded')),return; end
if(get(handles.adjustment_checkbox,'Value'))
    coeffs_repeat=getappdata(handles.output,'coeffs_repeat_adjusted');
    coeffs_unique=getappdata(handles.output,'coeffs_unique_adjusted');
else
    coeffs_repeat=getappdata(handles.output,'coeffs_repeat');
    coeffs_unique=getappdata(handles.output,'coeffs_unique');
end
freq=getappdata(handles.output,'freq');

% get cell list
ind=get(handles.cell_listbox,'Value');
N = length(ind); % number of cells

% calculate entropies
trial_length=getappdata(handles.output,'trial_length');
[Crep,Grep] = entropy_coeffs(coeffs_repeat(ind,:,:),trial_length);
[Cuni,Guni] = entropy_coeffs(coeffs_unique(ind,:,:),trial_length);

if(N==1)
    Crep=Crep'; Cuni=Cuni';
end
if(get(handles.smooth_checkbox,'Value'))
    window=find_index(freq,5);
    for i = 1:length(ind)
        Crep(i,:)=smooth(Crep(i,:),window);
        Cuni(i,:)=smooth(Cuni(i,:),window);
    end
    Grep=smooth(Grep,window)';
    Guni=smooth(Guni,window)';
end

colors=distinguishable_colors(N,'w');
colors_dark=colors*.7;
colors_light=1-(1-colors)/2.5;

% plot entropies
ax=handles.ax_entropy;
cla(ax); hold(ax,'all');
set(ax,'colororder',colors_light);
pE_rep=plot(ax,freq,Crep','linesmooth','on');
set(ax,'colororder',colors_dark);
pE_uni=plot(ax,freq,Cuni','linesmooth','on');
grid(ax,'on');
ylabel1=ylabel(ax,'Entropy (bits/s)','fontsize',10);
set(ax,'xlim',[0 freq(end)],'xtickmode','auto','ytickmode','auto');


% plot informations
I_cell=(Cuni-Crep);
I_group=(Guni-Grep);
R = 1-(sum(I_group)./sum(I_cell(:))); % should we report redundancy?
ax=handles.ax_info;
cla(ax); hold(ax,'all');
C_cell=cumsum(I_cell');
C_group=cumsum(I_group);

% with one cell we might have to transpose
C_total=cumsum(sum(I_cell,1));


set(ax,'colororder',colors);
pI_cell=plot(ax,freq,C_cell,'linesmooth','on');
pI_group=plot(ax,freq,C_group,'color',[.5 .5 .5],'linewidth',3,'linesmooth','on');
pI_total=plot(ax,freq,C_total,'k','linewidth',3,'linesmooth','on');
grid(ax,'on');
ylabel2=ylabel(ax,'Information (bits/s)','fontsize',10);
set(ax,'xlim',[0 freq(end)],'xtickmode','auto','ytickmode','auto');

if(get(handles.smooth_checkbox,'Value'))
    set([pE_rep pE_uni pI_cell],'linewidth',2);
end

% update plot handles
setappdata(handles.output,'pE_rep',pE_rep);
setappdata(handles.output,'pE_uni',pE_uni);
setappdata(handles.output,'pI_cell',pI_cell);
setappdata(handles.output,'pI_group',pI_group);
setappdata(handles.output,'pI_total',pI_total);
setappdata(handles.output,'ylabel1',ylabel1);
setappdata(handles.output,'ylabel2',ylabel2);

update_visibility(handles);

% set status bar information
set(handles.status_label,'String',sprintf(...
    'Cell Total: %2.1f bits/s     Group: %2.1f bits/s     Redundancy: %1.2f',C_total(end),C_group(end),R));


% determine what's visible on the screen. Also updates axis limits
function update_visibility(handles)
if(~getappdata(handles.output,'loaded')),return; end
pE_rep=getappdata(handles.output,'pE_rep');
pE_uni=getappdata(handles.output,'pE_uni');
pI_cell=getappdata(handles.output,'pI_cell');
pI_group=getappdata(handles.output,'pI_group');
pI_total=getappdata(handles.output,'pI_total');
ylabel1=getappdata(handles.output,'ylabel1');
ylabel2=getappdata(handles.output,'ylabel2');

visible=[];
invisible=[];
if(get(handles.entropy_checkbox,'Value'))
    visible=[visible pE_rep(:)' pE_uni(:)'];
else
    invisible=[invisible pE_rep(:)' pE_uni(:)'];
end

if(get(handles.cellinfo_checkbox,'Value'))
    visible=[visible pI_cell(:)'];
else
    invisible=[invisible pI_cell(:)'];
end

if(get(handles.sumtotal_checkbox,'Value'))
    visible=[visible pI_total];
else
    invisible=[invisible pI_total];
end

if(get(handles.groupinfo_checkbox,'Value'))
    visible=[visible pI_group];
else
    invisible=[invisible pI_group];
end

set(visible,'visible','on');
set(invisible,'visible','off');

% determine size and location of plots
loc1=getappdata(handles.output,'loc1');
loc2=getappdata(handles.output,'loc2');
loc3=getappdata(handles.output,'loc3');

entropy_plot=get(handles.entropy_checkbox,'Value');
information_plot=get(handles.information_checkbox,'Value');

% both visible
if(entropy_plot && information_plot)
    set(handles.ax_entropy,'position',loc1);
    set(handles.ax_info,'position',loc2);
    set([handles.ax_entropy handles.ax_info ylabel1 ylabel2],'visible','on');
% entropy plot only
elseif(entropy_plot)
    ch=allchild(handles.ax_info);
    set([ch(:)' handles.ax_info ylabel2],'visible','off');
    set(handles.ax_entropy,'position',loc3);
    set([handles.ax_entropy ylabel1],'visible','on');
% information plot noly
elseif(information_plot)
   ch=allchild(handles.ax_entropy);
   set([ch(:)' handles.ax_entropy ylabel1],'visible','off');
   set(handles.ax_info,'position',loc3);
   set([handles.ax_info ylabel2],'visible','on');
% none are visible
else
    ch1=allchild(handles.ax_entropy);
    ch2=allchild(handles.ax_info);
    set([ch1(:)' ch2(:)' handles.ax_info handles.ax_entropy ylabel1 ylabel2],'visible','off');
end




% --- Executes on selection change in cell_listbox.
function cell_listbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to cell_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns cell_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cell_listbox
update_plots(handles);


% --- Executes during object creation, after setting all properties.
function cell_listbox_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to cell_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in allcells_checkbox.
function allcells_checkbox_Callback(hObject, ~, handles) %#ok<DEFNU>
% hObject    handle to allcells_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of allcells_checkbox
if(~getappdata(handles.output,'loaded')),return; end
if(get(hObject,'Value'))
    setappdata(handles.output,'selected_old',get(handles.cell_listbox,'Value'));
    set(handles.cell_listbox,'Value',1:length(get(handles.cell_listbox,'String')));
else
    set(handles.cell_listbox,'Value',getappdata(handles.output,'selected_old'));
end
update_plots(handles);



function maxfreq_field_Callback(hObject, ~, handles) %#ok<DEFNU>
% hObject    handle to maxfreq_field (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxfreq_field as text
%        str2double(get(hObject,'String')) returns contents of maxfreq_field as a double
MAX_FREQ=getappdata(handles.output,'MAX_FREQ');
val=str2double(get(hObject,'String'));
if(isnan(val) || val<1)
    set(hObject,'String','1');
end
if(val~=MAX_FREQ)
    setappdata(handles.output,'MAX_FREQ',val);
    update_coefficients(handles,val);
    update_plots(handles);
end


% --- Executes during object creation, after setting all properties.
function maxfreq_field_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to maxfreq_field (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in adjustment_checkbox.
function adjustment_checkbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to adjustment_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of adjustment_checkbox
update_plots(handles);


% --- Executes on button press in entropy_checkbox.
function entropy_checkbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to entropy_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of entropy_checkbox
update_visibility(handles);


% --- Executes on button press in information_checkbox.
function information_checkbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to information_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of information_checkbox
update_visibility(handles);

% --- Executes on button press in cellinfo_checkbox.
function cellinfo_checkbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to cellinfo_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cellinfo_checkbox
update_visibility(handles);

% --- Executes on button press in groupinfo_checkbox.
function groupinfo_checkbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to groupinfo_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of groupinfo_checkbox
update_visibility(handles);

% --- Executes on button press in sumtotal_checkbox.
function sumtotal_checkbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to sumtotal_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sumtotal_checkbox
update_visibility(handles);

% --- Executes on button press in smooth_checkbox.
function smooth_checkbox_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to smooth_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of smooth_checkbox
update_plots(handles);

% --- Executes when figure1 is resized.
function figure1_ResizeFcn(~, ~, ~) %#ok<DEFNU>
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
